# include <iostream>
# include <vector>
# include <algorithm>
# include <queue>
using namespace std;

const long long INF=1e18;
const int MAX=2e5+11;
vector<int> spec;
vector<pair<int, long long>> a[MAX];
long long dist[5][MAX];
int n,k,m;

void dijkstra(int id)
{
    for(int i=1;i<=n;i++) dist[id][i]=INF;

    dist[id][spec[id]]=0;
    priority_queue<pair<long long, int>> q;
    q.push({0,spec[id]});
    while(q.size()>0)
    {
        long long d=-q.top().first;
        int u=q.top().second;
        q.pop();

        if(dist[id][u]<d) continue;
        for(pair<int, long long> p: a[u])
        {
            if(dist[id][p.first]>d+p.second)
            {
                dist[id][p.first]=d+p.second;
                q.push({-dist[id][p.first],p.first});
            }
        }
    }
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);cout.tie(0);

    cin>>n>>k>>m;
    for(int i=1;i<=k;i++) {int x;cin>>x;spec.push_back(x);}
    for(int i=1;i<=m;i++)
    {
        int u,v;
        long long w;
        cin>>u>>v>>w;

        a[u].push_back({v,w});
        a[v].push_back({u,w});
    }

    for(int i=0;i<k;i++) dijkstra(i);

    long long ans=INF;
    for(int i=1;i<=n;i++)
    {
        long long w=0;
        for(int j=0;j<k;j++) w+=dist[j][i];
        ans=min(ans,w);
    }

    cout<<ans<<"\n";

    return 0;
}
