# include <iostream>
# include <vector>
# include <algorithm>
# include <queue>
using namespace std;

const long long INF=1e18;
const int MAX=1e3+11;
int spec[MAX];
vector<pair<int, long long>> a[MAX];
long long dist[MAX][MAX];
int n,k,m;

void dijkstra(int id)
{
    for(int i=1;i<=n;i++) dist[id][i]=INF;

    dist[id][id]=0;
    priority_queue<pair<long long, int>> q;
    q.push({0,id});
    while(q.size()>0)
    {
        long long d=-q.top().first;
        int u=q.top().second;
        q.pop();

        if(dist[id][u]<d) continue;
        for(pair<int, long long> p: a[u])
        {
            if(dist[id][p.first]>d+p.second)
            {
                dist[id][p.first]=d+p.second;
                q.push({-dist[id][p.first],p.first});
            }
        }
    }
}

long long find_mst(vector<int> v)
{
    long long ans=INF;
    for(int i=1;i<=n;i++)
    {
        long long w=0;
        for(int x: v) w+=dist[x][i];
        ans=min(ans,w);
    }

    return ans;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);cout.tie(0);

    cin>>n>>k>>m;
    for(int i=0;i<k;i++) cin>>spec[i];
    for(int i=1;i<=m;i++)
    {
        int u,v;
        long long w;
        cin>>u>>v>>w;

        a[u].push_back({v,w});
        a[v].push_back({u,w});
    }

    for(int i=1;i<=n;i++) dijkstra(i);

    long long ans=INF;
    vector<int> ve;
    for(int i=0;i<k;i++) ve.push_back(spec[i]);
    ans=min(ans,find_mst(ve));

    for(int u=1;u<=n;u++)
    {
        for(int mask=0;mask<(1<<k);mask++)
        {
            vector<int> ve1, ve2;
            for(int bit=0;bit<k;bit++)
            {
                if(((1<<bit)&mask)>0) ve1.push_back(spec[bit]);
                else ve2.push_back(spec[bit]);
            }

            ve1.push_back(u);
            ve2.push_back(u);
            long long curr=find_mst(ve1)+find_mst(ve2);
            //cout<<mask<<":"<<curr<<"\n";
            ans=min(ans,curr);
        }
    }

    cout<<ans<<"\n";

    return 0;
}

