# include <iostream>
# include <vector>
# include "saddle.h"
//# include "Lgrader.cpp"
using namespace std;

const long long INF=1e18+111;
const int INF2=1e9;
const int MAX=512;
long long a[MAX][MAX];
int adj[4][2]={{1,0},{0,1},{-1,0},{0,-1}};
int N,M;

bool in(int x, int y)
{
    return (1<=x and x<=N and 1<=y and y<=M);
}

long long get_val(int x, int y)
{
    if(!in(x,y)) return INF;

    if(a[x][y]!=0) return a[x][y];
    a[x][y]=value(x,y);
    return a[x][y];
}

pair<int, int> dq(int row, int l, int r)
{
    //cout<<l<<" "<<r<<endl;

    if(l>r) return {INF2,INF2};

    int mid=(l+r)/2;
    long long val=get_val(row,mid);
    long long le=get_val(row,mid-1);
    long long ri=get_val(row,mid+1);
    if(le>val and val<ri) return {row,mid};

    if(l==r) return {INF2,INF2};

    if(le<ri) return dq(row,l,mid);
    else return dq(row,mid+1,r);

    /*
    pair<int, int> ans=dq(l,mid);
    if(ans.first!=INF2) return ans;
    return dq(mid+1,r);
    */
}

bool check(int x, int y)
{
    if(!in(x,y)) return false;

    long long d=get_val(x,y);
    for(int i=0;i<4;i++)
    {
        int x2=x+adj[i][0];
        int y2=y+adj[i][1];

        if(in(x2,y2) and get_val(x2,y2)<=d) return false;
    }

    return true;
}

pair <int, int> find_saddle_point (int _N, int _M)
{
    N=_N;
    M=_M;

    vector<pair<int, int>> v;
    for(int i=1;i<=N;i++) v.push_back(dq(i,1,M));

    for(pair<int, int> p: v) if(check(p.first,p.second)) return p;
}

