#include <bits/stdc++.h>
using namespace std;

const long long INF = 1e18;
const int MAXN = 1e5 + 1;
const int MASK = (1 << 6);
int N, K, M;
vector<pair<int, int>> Graph[MAXN];
int Speacial[MAXN];
long long dp[MAXN][MASK];

void Upgrade_Speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

void Read()
{
    cin >> N >> K >> M;

    for(int i = 0; i < K; i++)
    {
        int U; cin >> U;
        Speacial[U] = i + 1;
    }

    for(int i = 0; i < M; i++)
    {
        int U, V, W; cin >> U >> V >> W;
        Graph[U].push_back({V, W});
        Graph[V].push_back({U, W});
    }
}

void Dejikstra()
{
    for(int i = 1; i <= N; i++)
    {
        for(int Mask = 0; Mask < (1 << K); Mask++)
        {
            dp[i][Mask] = INF;
        }
    }

    priority_queue<tuple<long long, int, int>> Pq;

    for(int i = 1; i <= N; i++)
    {
        if(Speacial[i] > 0)
        {
            dp[i][(1 << (Speacial[i] - 1))] = 0;

            if(Pq.empty())
            {
                Pq.push({0, i, (1 << (Speacial[i] - 1))});
            }
        }
        else
        {
            dp[i][0] = 0;
        }
    }

    while(!Pq.empty())
    {
        tuple<long long, int, int> Top = Pq.top();
        Pq.pop();
        int U = get<1>(Top);
        int Mask = get<2>(Top);

        for(auto& V : Graph[U])
        {
            long long W = V.second + dp[U][Mask];
            int NewMask = Mask;

            if(Speacial[V.first] > 0)
            {
                if(!(Mask & (1 << (Speacial[V.first] - 1))))
                {
                    NewMask += (1 << (Speacial[V.first] - 1));
                }
            }

            if(dp[V.first][NewMask] > W)
            {
                dp[V.first][NewMask] = W;
                Pq.push({-W, V.first, NewMask});
            }
        }
    }
}

void Solve()
{
    Dejikstra();
    long long Answer = INF;
    int Mask = (1 << K) - 1;

    for(int i = 1; i <= N; i++)
    {
        Answer = min(Answer, dp[i][Mask]);
    }

    cout << Answer;
}

int main()
{
    Upgrade_Speed();
    Read();
    Solve();
    return 0;
}

