#include <bits/stdc++.h>
using namespace std;

const long long INF = 1e18;
const int MAXN = 1e5 + 1;
int N, K, M;
vector<pair<int, int>> Graph[MAXN];
vector<int> A;
long long dp[MAXN][6];

void Upgrade_Speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

void Read()
{
    cin >> N >> K >> M;

    for(int i = 0; i < K; i++)
    {
        int U; cin >> U;
        A.push_back(U);
    }

    for(int i = 0; i < M; i++)
    {
        int U, V, W; cin >> U >> V >> W;
        Graph[U].push_back({V, W});
        Graph[V].push_back({U, W});
    }
}

void Dejikstra(int Start, int Index)
{
    for(int i = 1; i <= N; i++)
    {
        dp[i][Index] = INF;
    }

    dp[Start][Index] = 0;

    priority_queue<pair<long long, int>> Pq;
    Pq.push({0, Start});

    while(!Pq.empty())
    {
        pair<long long, int> Top = Pq.top();
        Pq.pop();
        int U = Top.second;

        for(auto& V : Graph[U])
        {
            long long W = V.second + dp[U][Index];

            if(dp[V.first][Index] > W)
            {
                dp[V.first][Index] = W;
                Pq.push({-W, V.first});
            }
        }
    }
}

void Solve()
{
    for(int i = 0; i < K; i++)
    {
        Dejikstra(A[i], i);
    }

    long long Answer = INF;

    for(int i = 1; i <= N; i++)
    {
        long long Total = 0;

        for(int j = 0; j < K; j++)
        {
            Total += dp[i][j];
        }

        Answer = min(Answer, Total);
    }

    cout << Answer;
}

int main()
{
    Upgrade_Speed();
    Read();
    Solve();
    return 0;
}

