#include <bits/stdc++.h>
#include "saddle.h"
using namespace std;

const int MAX = 501;
const long long INF = 1e18;
int DirsX[5] = {0, 0, -1, 1};
int DirsY[5] = {1, -1, 0, 0};
bool Visited[MAX][MAX];

pair<int, int> Dfs(int X, int Y, int N, int M, long long Starter)
{
    queue<tuple<int, int, long long>> Q;
    Q.push({X, Y, Starter});
    Visited[X][Y] = true;

    while(!Q.empty())
    {
        tuple<int, int, long long> Top = Q.front();
        Q.pop();
        int Ox = get<0>(Top);
        int Oy = get<1>(Top);
        long long Current = get<2>(Top);
        long long Min = INF;
        int MinX = 0, MinY = 0;
        ////cout << Ox << " " << Oy << '\n';

        for(int i = 0; i < 4; i++)
        {
            int Nx = Ox + DirsX[i];
            int Ny = Oy + DirsY[i];

            if(Nx < 1 || Nx > N || Ny < 1 || Ny > M)
            {
                continue;
            }

            if(Visited[Nx][Ny])
            {
                continue;
            }

            Visited[Nx][Ny] = true;
            long long Value = value(Nx, Ny);

            if(Min < Value)
            {
                MinX = Nx;
                MinY = Ny;
            }
        }

        if(Current > Min)
        {
            Q.push({MinX, MinY, Min});
        }
        else
        {
            return {Ox, Oy};
        }
    }
}

pair<int, int> find_saddle_point(int N, int M)
{
    long long Min = INF;
    int MinX, MinY;

    for(int i = 1; i <= M; i++)
    {
        long long Value = value(1, i);

        if(Min > Value)
        {
            MinX = 1;
            MinY = i;
            Min = Value;
        }
    }

    return Dfs(MinX, MinY, N, M, Min);
}
