#include <bits/stdc++.h>
#include "saddle.h"
using namespace std;

const int MAX = 510;
const long long INF = 1e18;
long long DirsX[5] = {0, 0, -1, 1};
long long DirsY[5] = {1, -1, 0, 0};
bool Visited[MAX][MAX];

pair<long long, long long> Dfs(long long X, long long Y, long long N, long long M, long long Starter)
{
    queue<tuple<long long, long long, long long>> Q;
    Q.push({X, Y, Starter});
    Visited[X][Y] = true;

    while(!Q.empty())
    {
        tuple<long long, long long, long long> Top = Q.front();
        Q.pop();
        long long Ox = get<0>(Top);
        long long Oy = get<1>(Top);
        long long Current = get<2>(Top);
        bool IsLocal = true;
        ////cout << Ox << " " << Oy << '\n';

        for(int i = 0; i < 4; i++)
        {
            int Nx = Ox + DirsX[i];
            int Ny = Oy + DirsY[i];

            if(Nx < 1 || Nx > N || Ny < 1 || Ny > M)
            {
                continue;
            }

            if(Visited[Nx][Ny])
            {
                continue;
            }

            Visited[Nx][Ny] = true;
            long long Value = value(Nx, Ny);

            if(Value < Current)
            {
                IsLocal = false;
                Q.push({Nx, Ny, Value});
                break;
            }
        }

        if(IsLocal)
        {
            return {Ox, Oy};
        }
    }
}

pair<int, int> find_saddle_point(int N, int M)
{
    long long Min = INF;
    long long MinX, MinY;

    for(int i = 1; i <= M; i++)
    {
        long long Value = value(1, i);
        Visited[1][i] = true;

        if(Min > Value)
        {
            MinX = 1;
            MinY = i;
            Min = Value;
        }
    }

    if(N == 1)
    {
        return {MinX, MinY};
    }

    return Dfs(MinX, MinY, N, M, Min);
}
