#include <bits/stdc++.h>
#include "saddle.h"
using namespace std;

long long v[501][501];
int N, M;

bool is_valid_cell(int x, int y) {
    return 0 < x && x <= N && 0 < y && y <= M;
}

pair <long long, pair <int, int>> ask(int x, int y) {
    if (!is_valid_cell(x, y)) return {INT_MAX, {x, y}};
    if (v[x][y] != 0) return {v[x][y], {x, y}};
    v[x][y] = value(x, y);

    return {v[x][y], {x, y}};
}

pair <long long, pair <int, int>> ask_group(int x, int y) {
    return min({ask(x - 1, y), ask(x + 1, y), ask(x, y - 1), ask(x, y + 1), ask(x, y)});
}

pair <int, int> find_saddle_point(int n, int m) {
    N = n;
    M = m;

    int x = (N + 1) / 2, y = (M + 1) / 2, br = 0;

    while (br < 4 * n * m) {
        auto val = ask_group(x, y);
        if (val == ask(x, y)) return {x, y};
        x = val.second.first;
        y = val.second.second;

        br++;
    }

    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= m; j++) {
            if (ask(i, j).first > min({ask(i - 1, j).first, ask(i + 1, j).first, ask(i, j - 1).first, ask(i, j + 1).first})) return {x, y};
        }
    }

    return {x, y};
}
