#include <bits/stdc++.h>

#define endl '\n'

using namespace std;

typedef long long ll;

const int MAXN = 1e5 + 10;
const int MAXH = 1e9 + 10;

int n;
int a[MAXN];
vector < int > x;
vector < int > y;

void read()
{
    cin >> n;
    for(int i = 1; i <= n; i++)
    {
        cin >> a[i];
    }
    sort(a + 1, a + n + 1);
}

int bin_search(int idx, int val)
{
    int left = idx + 1;
    int right = n + 1;
    int mid;

    while(right - left > 1)
    {
        mid = left + (right - left) / 2;
        if(a[mid] - a[idx] <= val)
            left = mid;
        else
            right = mid;
    }

    return a[left] - a[idx] == val ? left : -1;
}

void make_y()
{
    int idx = 1;
    for(int ptr = 0; ptr < x.size(); ptr++)
    {
        while(idx <= n && idx != x[ptr])
        {
            y.push_back(idx);
            idx++;
        }
        idx = max(idx, x[ptr] + 1);
    }
    while(idx <= n)
    {
        y.push_back(idx);
        idx++;
    }
}

bool check()
{
    y.clear();
    make_y();

    /*

    cout << "Current state of y : ";
    for(int val : y)
    {
        cout << a[val] << " ";
    }
    cout << endl;

    */

    if(x.size() + y.size() != n)
        return false;

    int last = -1;
    for(int i = 1; i < y.size(); i++)
    {
        int cur = a[y[i]] - a[y[i - 1]];

        if(last == -1)
            last = cur;
        else if(last != cur)
            return false;
    }

    return true;
}

void print()
{
    cout << x.size() << " " << y.size() << endl;
    for(int val : x)
    {
        cout << a[val] << " ";
    }
    cout << endl;
    for(int val : y)
    {
        cout << a[val] << " ";
    }
    cout << endl;
    exit(0);
}

void rec(int idx, int cur_diff)
{
    x.push_back(idx);
    /*

    cout << "Current state of x : ";
    for(int val : x)
    {
        cout << a[val] << " ";
    }
    cout << endl;
    */

    if(check())
        print();

    if(idx == n)
    {
        x.pop_back();
        return;
    }

    if(cur_diff == -1)
    {
        for(int i = idx + 1; i <= n; i++)
        {
            int cur = a[i] - a[idx];
            rec(i, cur);
        }
    }
    else
    {
        int res = bin_search(idx, cur_diff);
        if(res != -1)
            rec(res, cur_diff);
    }

    x.pop_back();
}

int main()
{
    ios_base :: sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    read();
    rec(1, -1);

    cout << -1 << endl;

    return 0;
}
