#include <bits/stdc++.h>

#define endl '\n'

using namespace std;

typedef long long ll;

const int MAXN = 1e3 + 10;
const int MAXM = 2e3 + 10;
const int INF = 3e18 + 10;

int n, m, p;
ll dist[MAXN][MAXN];
vector < int > special;

void read()
{
    cin >> n >> p >> m;
    for(int i = 1; i <= n; i++)
    {
        for(int j = 1; j <= n; j++)
        {
            dist[i][j] = INF;
        }
        dist[i][i] = 0;
    }
    for(int i = 1; i <= p; i++)
    {
        int s;
        cin >> s;
        special.push_back(s);
    }
    for(int i = 1; i <= m; i++)
    {
        int u, v, cost;
        cin >> u >> v >> cost;
        dist[u][v] = dist[v][u] = cost;
    }
}

void floyd()
{
    for(int k = 1; k <= n; k++)
    {
        for(int i = 1; i <= n; i++)
        {
            for(int j = 1; j <= n; j++)
            {
                dist[i][j] = min(dist[i][j], dist[i][k] + dist[k][j]);
            }
        }
    }
}

void print()
{
    if(p == 2)
    {
        cout << dist[special[0]][special[1]] << endl;
    }
    else
    {
        ll ans = INF;
        for(int i = 1; i <= n; i++)
        {
            ans = min(ans, dist[special[0]][i] + dist[special[1]][i] + dist[special[2]][i]);
        }
        cout << ans << endl;
    }
}

int main()
{
    ios_base :: sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    read();
    floyd();
    print();

    return 0;
}
