#include <bits/stdc++.h>

#define endl '\n'

using namespace std;

typedef long long ll;

const int MAXN = 1e5 + 10;
const int MAXM = 2e5 + 10;
const ll INF = 3e18 + 10;

struct edge
{
    int node;
    ll cost;
    int idx;
    edge()
    {
        node = 1;
        cost = INF;
        idx = 1;
    }
    edge(int _node, ll _cost, int _idx)
    {
        node = _node;
        cost = _cost;
        idx = _idx;
    }

    bool operator<(const edge&e)const
    {
        return cost > e.cost;
    }
};

int n, m, p;
vector < edge > adj[MAXN];
vector < int > special;
bool used[MAXM];
bool visited[MAXN];
edge dist[MAXN];
ll ans = INF;

void read()
{
    cin >> n >> p >> m;
    for(int i = 1; i <= p; i++)
    {
        int s;
        cin >> s;
        special.push_back(s);
    }
    for(int i = 1; i <= m; i++)
    {
        int u, v, cost;
        cin >> u >> v >> cost;
        adj[u].push_back({v, cost, i});
        adj[v].push_back({u, cost, i});
    }
}

void init()
{
    for(int i = 1; i <= n; i++)
    {
        dist[i] = {0, INF, 0};
        visited[i] = false;
    }
}

ll dijkstra(int start, int finish)
{
    init();

    priority_queue < edge > pq;
    pq.push(edge(start, 0, 0));
    dist[start] = edge(start, 0, 0);

    while(!pq.empty())
    {
        edge e = pq.top();
        int u = e.node;
        ll cur = e.cost;
        pq.pop();

        if(visited[u])
            continue;

        visited[u] = true;

        for(edge nb : adj[e.node])
        {
            int v = nb.node;
            ll cost = nb.cost;
            int idx = nb.idx;

            if(used[idx])
                cost = 0;

            if(dist[v].cost > dist[u].cost + cost)
            {
                dist[v] = edge(v, dist[u].cost + cost, idx);
                pq.push(dist[v]);
            }
        }
    }

    return dist[finish].cost;
}

void mark_edges(int node)
{
    if(dist[node].node == node)
        return;

    used[dist[node].idx] = true;

    mark_edges(dist[node].node);
}

void solve()
{
    do
    {
        for(int i = 1; i <= m; i++)
        {
            used[i] = false;
        }
        ll cur_cost = 0;
        for(int i = 1; i < special.size(); i++)
        {
            int prev = special[i - 1];
            int cur = special[i];

            cur_cost += dijkstra(prev, cur);
            mark_edges(cur);
        }
        ans = min(ans, cur_cost);

    }while(next_permutation(special.begin(), special.end()));

    cout << ans << endl;
}

int main()
{
    ios_base :: sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    read();
    solve();

    return 0;
}
