#include <bits/stdc++.h>

#define endl '\n'

using namespace std;

typedef long long ll;

const int MAXN = 1e5 + 10;
const int MAXM = 2e5 + 10;
const ll INF = 3e18 + 10;

struct edge
{
    int node;
    ll cost;
    int idx;
    edge()
    {
        node = 1;
        cost = INF;
        idx = 1;
    }
    edge(int _node, ll _cost, int _idx)
    {
        node = _node;
        cost = _cost;
        idx = _idx;
    }

    bool operator<(const edge&e)const
    {
        return cost > e.cost;
    }
};

int n, m, p;
vector < edge > adj[MAXN];
vector < int > special;
bool used[MAXM];
bool visited[MAXN];
edge dist[5][MAXN];
ll ans = INF;

void read()
{
    cin >> n >> p >> m;
    for(int i = 1; i <= p; i++)
    {
        int s;
        cin >> s;
        special.push_back(s);
    }
    for(int i = 1; i <= m; i++)
    {
        int u, v, cost;
        cin >> u >> v >> cost;
        adj[u].push_back({v, cost, i});
        adj[v].push_back({u, cost, i});
    }
}

void dijkstra(int idx)
{
    priority_queue < edge > pq;
    dist[idx][special[idx]] = edge(special[idx], 0, 0);

    pq.push(dist[idx][special[idx]]);

    while(!pq.empty())
    {
        edge e = pq.top();
        pq.pop();

        int u = e.node;

        if(visited[u])
            continue;

        visited[u] = true;

        for(edge nb : adj[u])
        {
            int v = nb.node;
            ll cost = nb.cost;

            if(dist[idx][v].cost > dist[idx][u].cost + cost)
            {
                dist[idx][v] = edge(v, dist[idx][u].cost + cost, nb.idx);
                pq.push(dist[idx][v]);
            }
        }
    }
}


void solve()
{
    for(int i = 0; i < p; i++)
    {
        for(int j = 1; j <= n; j++)
        {
            dist[i][j] = edge(0, INF, 0);
            visited[j] = false;
        }
        dijkstra(i);
    }

    if(p == 2)
    {
        cout << dist[0][special[1]] << endl;
        return;
    }
    else if(p == 3)
    {
        for(int i = 1; i <= n; i++)
        {
            ll cur_cost = dist[0][i] + dist[1][i] + dist[2][i];

            ans = min(ans, cur_cost);
        }

        cout << ans << endl;
    }
    else if(p == 4)
    {
        int new_node = -1;
        ll opt_cost;

        opt_cost = INF;
        for(int i = 1; i <= n; i++)
        {
            ll cur_cost = dist[0][i] + dist[1][i] + dist[2][i];
            if(opt_cost > cur_cost)
            {
                opt_cost = cur_cost;
                new_node = i;
            }
        }
        ans = min(ans, opt_cost + dist[3][new_node]);


        opt_cost = INF;
        for(int i = 1; i <= n; i++)
        {
            ll cur_cost = dist[0][i] + dist[1][i] + dist[3][i];
            if(opt_cost > cur_cost)
            {
                opt_cost = cur_cost;
                new_node = i;
            }
        }
        ans = min(ans, opt_cost + dist[2][new_node]);


        opt_cost = INF;
        for(int i = 1; i <= n; i++)
        {
            ll cur_cost = dist[0][i] + dist[3][i] + dist[2][i];
            if(opt_cost > cur_cost)
            {
                opt_cost = cur_cost;
                new_node = i;
            }
        }
        ans = min(ans, opt_cost + dist[1][new_node]);


        opt_cost = INF;
        for(int i = 1; i <= n; i++)
        {
            ll cur_cost = dist[3][i] + dist[1][i] + dist[2][i];
            if(opt_cost > cur_cost)
            {
                opt_cost = cur_cost;
                new_node = i;
            }
        }
        ans = min(ans, opt_cost + dist[0][new_node]);

        cout << ans << endl;
    }
}

int main()
{
    ios_base :: sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    read();
    solve();

    return 0;
}
