#include <bits/stdc++.h>

#define endl '\n'

using namespace std;

typedef long long ll;

const int MAXN = 1e5 + 10;
const int MAXM = 2e5 + 10;
const ll INF = 3e18 + 10;

struct edge
{
    int node;
    ll cost;
    int idx;
    edge()
    {
        node = 1;
        cost = INF;
        idx = 1;
    }
    edge(int _node, ll _cost, int _idx)
    {
        node = _node;
        cost = _cost;
        idx = _idx;
    }

    bool operator<(const edge&e)const
    {
        return cost > e.cost;
    }
};

int n, m, p;
vector < edge > adj[MAXN];
vector < int > special;
bool used[MAXM];
bool visited[MAXN];
edge dist[5][MAXN];

ll d[MAXN];
ll ans = INF;

void read()
{
    cin >> n >> p >> m;
    for(int i = 1; i <= p; i++)
    {
        int s;
        cin >> s;
        special.push_back(s);
    }
    for(int i = 1; i <= m; i++)
    {
        int u, v, cost;
        cin >> u >> v >> cost;
        adj[u].push_back({v, cost, i});
        adj[v].push_back({u, cost, i});
    }
}

void dijkstra(int idx)
{
    priority_queue < edge > pq;
    dist[idx][special[idx]] = edge(special[idx], 0, 0);

    pq.push(dist[idx][special[idx]]);

    while(!pq.empty())
    {
        edge e = pq.top();
        pq.pop();

        int u = e.node;

        if(visited[u])
            continue;

        visited[u] = true;

        for(edge nb : adj[u])
        {
            int v = nb.node;
            ll cost = nb.cost;

            if(dist[idx][v].cost > dist[idx][u].cost + cost)
            {
                dist[idx][v] = edge(v, dist[idx][u].cost + cost, nb.idx);
                pq.push(dist[idx][v]);
            }
        }
    }
}

ll dijkstra2(int from, int to)
{
    priority_queue < edge > pq;
    d[from] = 0;
    pq.push(edge(from, 0, 0));

    while(!pq.empty())
    {
        edge e = pq.top();
        pq.pop();

        int u = e.node;

        if(visited[u])
            continue;

        visited[u] = true;

        for(edge nb : adj[u])
        {
            int v = nb.node;
            ll cost = nb.cost;

            if(d[v] > d[u] + cost)
            {
                d[v] = d[u] + cost;
                pq.push({v, d[v], nb.idx});
            }
        }
    }

    return d[to];
}


void solve()
{
    for(int i = 0; i < p; i++)
    {
        for(int j = 1; j <= n; j++)
        {
            dist[i][j] = edge(0, INF, 0);
            visited[j] = false;
        }
        dijkstra(i);
    }

    if(p == 2)
    {
        cout << dist[0][special[1]].cost << endl;
        return;
    }
    else if(p == 3)
    {
        for(int i = 1; i <= n; i++)
        {
            ll cur_cost = dist[0][i].cost + dist[1][i].cost + dist[2][i].cost;

            ans = min(ans, cur_cost);
        }

        cout << ans << endl;
    }
    else if(p == 4)
    {
        /*
        int new_node = -1;
        ll opt_cost;

        opt_cost = INF;
        for(int i = 1; i <= n; i++)
        {
            ll cur_cost = dist[0][i].cost + dist[1][i].cost + dist[2][i].cost;
            if(opt_cost > cur_cost)
            {
                opt_cost = cur_cost;
                new_node = i;
            }
        }
        ans = min(ans, opt_cost + dist[3][new_node].cost);


        opt_cost = INF;
        for(int i = 1; i <= n; i++)
        {
            ll cur_cost = dist[0][i].cost + dist[1][i].cost + dist[3][i].cost;
            if(opt_cost > cur_cost)
            {
                opt_cost = cur_cost;
                new_node = i;
            }
        }
        ans = min(ans, opt_cost + dist[2][new_node].cost);


        opt_cost = INF;
        for(int i = 1; i <= n; i++)
        {
            ll cur_cost = dist[0][i].cost + dist[3][i].cost + dist[2][i].cost;
            if(opt_cost > cur_cost)
            {
                opt_cost = cur_cost;
                new_node = i;
            }
        }
        ans = min(ans, opt_cost + dist[1][new_node].cost);


        opt_cost = INF;
        for(int i = 1; i <= n; i++)
        {
            ll cur_cost = dist[3][i].cost + dist[1][i].cost + dist[2][i].cost;
            if(opt_cost > cur_cost)
            {
                opt_cost = cur_cost;
                new_node = i;
            }
        }
        ans = min(ans, opt_cost + dist[0][new_node].cost);

        cout << ans << endl;
        */

        int new_node1 = -1;
        ll opt_cost1 = INF;

        for(int i = 1; i <= n; i++)
        {
            ll cur_cost = dist[0][i].cost + dist[1][i].cost;

            if(cur_cost < opt_cost1)
            {
                opt_cost1 = cur_cost;
                new_node1 = i;
            }
        }

        int new_node2 = -1;
        ll opt_cost2 = INF;

        for(int i = 1; i <= n; i++)
        {
            ll cur_cost = dist[2][i].cost + dist[3][i].cost;

            if(cur_cost < opt_cost2)
            {
                opt_cost2 = cur_cost;
                new_node2 = i;
            }
        }

        for(int i = 1; i <= n; i++)
        {
            visited[i] = false;
            d[i] = INF;
        }

        ans = 0;

        /**

        if(new_node1 != special[2] && new_node1 != special[3])
            ans += opt_cost1;

        if(new_node2 != special[0] && new_node2 != special[1])
            ans += opt_cost2;

        */

        ans += opt_cost1;
        ans += opt_cost2;

        ans += dijkstra2(new_node1, new_node2);

        cout << ans << endl;
    }
}

int main()
{
    ios_base :: sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    read();
    solve();

    return 0;
}
/**
5 3 8
5 2 3
1 2 2
2 3 3
3 4 2
4 5 5
5 1 3
3 1 3
3 5 6
4 2 2

5 4 8
5 2 3 4
1 2 2
2 3 3
3 4 2
4 5 5
5 1 3
3 1 3
3 5 6
4 2 2
*/
