#include <iostream>
#include <map>
#include <vector>
#include <algorithm>
#include <bitset>
using namespace std;
#define ll long long
ll n;
ll h[100001];
bitset<100001> visited[5];
pair<ll, ll> dif[5][100001];
ll partOfStepIdx[5][100001];
vector<ll> steps[5];
map<ll, ll> numberOfSteps[5];
bool debug = 0;

bool checkIfSol(ll iter, ll stIdx, ll step) {
    ll last = stIdx, lastUnused = -1;
    visited[iter][stIdx] = 1;
    ll st2 = -1, cnt1 = 1;
    for (ll i = 0; i < n; i++) {
        if (i == stIdx) {
            i++;
        }
        if (h[i] - h[last] == step) {
            if (lastUnused != -1) {
                dif[iter][i].first = h[i] - h[lastUnused];
            } else {
                dif[iter][i].first = -1;
            }
            last = i;
            visited[iter][i] = 1;
            cnt1++;
        } else {
            lastUnused = i;
            if (st2 == -1) {
                st2 = i;
            }
        }
    }
    if (st2 == -1) {
        cout << n - 1 << " 1\n";
        for (ll i = 0; i < n - 1; i++) {
            cout << h[i] << " ";
        }
        cout << "\n" << h[n - 1] << "\n";
        debug = 1;
        return 1;
    }
    lastUnused = -1;
    for (ll i = n - 1; i >= 0; i--) {
        if (visited[iter][i]) {
            if (lastUnused != -1) {
                dif[iter][i].second = h[lastUnused] - h[i];
            } else {
                dif[iter][i].second = -1;
            }
        } else {
            lastUnused = i;
        }
    }
    lastUnused = st2;
    for (ll i = st2 + 1; i < n; i++) {
        if (visited[iter][i]) {
            partOfStepIdx[iter][i] = steps[iter].size();
        } else {
            steps[iter].push_back(h[i] - h[lastUnused]);
            numberOfSteps[iter][h[i] - h[lastUnused]]++;
            lastUnused = i;
        }
    }
    bool found = 1;
    for (ll i = 1; i < steps[iter].size(); i++) {
        if (steps[iter][i] != steps[iter][i - 1]) {
            found = 0;
            break;
        }
    }
    if (found) {
        cout << cnt1 << " " << n - cnt1 << "\n";
        for (ll i = 0; i < n; i++) {
            if (visited[iter][i]) { cout << h[i] << " "; }
        }
        cout << "\n";
        for (ll i = 0; i < n; i++) {
            if (!visited[iter][i]) { cout << h[i] << " "; }
        }
        debug = 1;
        return 1;
    }
    ll sz = steps[iter].size(), lastStepBroken = -1, step2 = -1, brokenCnt = 0;
    for (ll i = n - 1; i >= 0; i--) {
        if (visited[iter][i]) {
            if ((dif[iter][i].second != -1 && dif[iter][i].first != dif[iter][i].second) || partOfStepIdx[iter][i] == lastStepBroken) {
                return 0;
            }
            if (step2 == -1) {
                step2 = dif[iter][i].first;
            } else {
                if(dif[iter][i].first != step2) {
                    return 0;
                }
            }
            lastStepBroken = partOfStepIdx[iter][i];
            if (dif[iter][i].second != -1) {
                sz--;
            }
            brokenCnt++;
            if (numberOfSteps[iter][step2] == sz) {
                cout << cnt1 - brokenCnt << " " << n - cnt1 + brokenCnt << "\n";
                ll tempCnt = 0;
                for (ll j = 0; j < n; j++) {
                    if (visited[iter][j]) {
                        cout << h[j] << " ";
                        tempCnt++;
                        if (tempCnt >= cnt1 - brokenCnt) {
                            break;
                        }
                    }
                }
                cout << "\n";
                tempCnt = 0;
                for (ll j = 0; j < n; j++) {
                    if (visited[iter][j] && tempCnt < cnt1 - brokenCnt) {
                        tempCnt++;
                    } else {
                        cout << h[j] << " ";
                    }
                }
                debug = 1;
                return 1;
            }
        }
    }
    return 0;
}

int main () {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin >> n;
    for (ll i = 0; i < n; i++) {
        cin >> h[i];
    }
    sort(h, h + n);
    if (n <= 1) {
        while (1) {}
    }
    if (n == 2) {
        cout << "1 1\n" << h[0] << "\n" << h[1] << "\n";
        return 0;
    }
    if (checkIfSol(0, 0, h[1] - h[0])) {
        return 0;
    }
    if (checkIfSol(1, 0, h[2] - h[0])) {
        return 0;
    }
    if (checkIfSol(2, 1, h[2] - h[1])) {
        return 0;
    }
    cout << "-1";
}
